package com.isoft91.gonn.gps.business.controller;


import com.isoft91.gonn.gps.business.service.impl.SUserSYNServiceImpl;
import com.isoft91.gonn.gps.sys.service.CommonMesServiceImpl;
import com.isoft91.gonn.gps.utils.Result.Ret;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.DigestUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;

@RestController
@RequestMapping("/userSYN")
public class SUserSYNController {
    

    @Autowired
    private SUserSYNServiceImpl sUserSYNService;

    @Value("${global.path.serverAuthenticateStaticKey}")
    private String key;
    @Value("${global.path.app_secret}")
    private String secret;

    @ApiOperation(value = "同步用户", notes = "同步用户")
    //@ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @GetMapping(value = "/synUser")
    public Ret addUser(String timestamp, String sign) {
        return sUserSYNService.synUser(timestamp, sign);
    }
   //后台同步数据
    @GetMapping(value = "/synInfo")
    public Ret synInfo() {
        String round =Long.toString(System.currentTimeMillis() / 1000L);
        String sign=secret+round+key;
        sign= CommonMesServiceImpl.sha1(sign);
        sign = DigestUtils.md5DigestAsHex(sign.getBytes());
        return sUserSYNService.synUser(round, sign);
    }
}
