package com.isoft91.gonn.gps.business.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.isoft91.gonn.gps.common.entity.DelStatus;
import com.isoft91.gonn.gps.common.entity.FlagStatus;
import com.isoft91.gonn.gps.common.entity.IdEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author wulingfang
 * @since 2021-06-28
 */
@Data

@Accessors(chain = true)
@TableName("oa_c_busi_conf")
public class OaCBusiConf implements Serializable {

    private static final long serialVersionUID = 1L;
    @TableId("id")
    @TableField(fill = FieldFill.INSERT)
    private String id;

    @TableField("type")
    private String type;

    @TableField("name")
    private String name;

    @TableField("key")
    private String key;

    @TableField("value")
    private String value;

    @TableField("pid")
    private Integer pid;

    @TableField("create_by")
    private String createBy;

    @TableField("create_date")
    private LocalDateTime createDate;

    @TableField("update_by")
    private String updateBy;

    @TableField("update_date")
    private LocalDateTime updateDate;

    @TableField("flag")
    private String flag;

    @TableField("remarks")
    private String remarks;

    /**
     * 对应单位id
     */
    @TableField("comid")
    private Integer comid;



    /**
     * 删除标记（0：正常；1：删除；2：审核）
     */
    @TableField(value="DEL_FLAG", fill = FieldFill.INSERT)
    protected String delFlag;




    /**
     * 设置删除
     */
    public void setDeleted(){
        this.setDelFlag(DelStatus.DELETED.getStatus());
    }

    /**
     * 设置非删除
     */
    public void setNotDeleted(){
        this.setDelFlag(DelStatus.NORMAL.getStatus());
    }


    /**
     * 设置启用
     */
    public void setStart(){
        this.setFlag(FlagStatus.NORMAL.getStatus());
    }

    /**
     * 设置停用
     */
    public void setStop(){
        this.setFlag(FlagStatus.ABNORMAL.getStatus());
    }

    /**
     * 设置非删除&启用
     */
    public void setNormal(){
        this.setFlag(FlagStatus.NORMAL.getStatus());
        this.setDelFlag(DelStatus.NORMAL.getStatus());
    }

    /**
     * 设置非删除&启用
     */
    public void setPublish(){
        this.setFlag(FlagStatus.NORMAL.getStatus());
        this.setDelFlag(DelStatus.NORMAL.getStatus());
    }


}
