package com.isoft91.gonn.gps.business.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import com.isoft91.gonn.gps.common.entity.DataEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 用户表
 * </p>
 *
 * @author jiangpengpeng
 * @since 2020-01-09
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("s_user")
public class SUser extends DataEntity {
    

    private static final long serialVersionUID = 1L;

    /**
     * 业务主键
     */
    @TableId("BUSINESS_ID")
    private String businessId;

    /**
     * 用户名
     */
    @TableField("LOGIN_NAME")
    private String loginName;

    /**
     * 密码
     */
    @TableField("PASSWORD")
    private String password;

    /**
     * 姓名
     */
    @TableField("NAME")
    private String name;

    /**
     * 性别（0：男，1：女）
     */
    @TableField("SEX")
    private String sex;

    /**
     * 手机号码
     */
    @TableField("PHONE")
    private String phone;

    /**
     * 部门表id
     */
    @TableField("DEPT_ID")
    private String deptId;

    /**
     * 邮箱
     */
    @TableField("EMAIL")
    private String email;

    /* *//**
     * 创建人
     *//*
    @TableField("CREATE_BY")
    private String createBy;

    *//**
     * 创建日期
     *//*
    @TableField("CREATE_DATE")
    private LocalDateTime createDate;

    *//**
     * 修改人
     *//*
    @TableField("UPDATE_BY")
    private String updateBy;

    *//**
     * 修改日期
     *//*
    @TableField("UPDATE_DATE")
    private LocalDateTime updateDate;

    *//**
     * 删除标识 1 删除 0 未删除 2 审核
     *//*
    @TableField("DEL_FLAG")
    private String delFlag;

    *//**
     * 启用标记（0：停用；1：启用）
     *//*
    @TableField("FLAG")
    private String flag;

    */
    /**
     * 备注
     */
    @TableField("REMARKS")
    private String remarks;


}
