package com.isoft91.gonn.gps.business.mapper;


import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.isoft91.gonn.gps.business.dto.QuerySDeptDTO;
import com.isoft91.gonn.gps.business.dto.ResultSDeptDTO;
import com.isoft91.gonn.gps.business.entity.SDept;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 * 部门表 Mapper 接口
 * </p>
 *
 * @author 91isoft
 * @since 2019-12-30
 */
public interface SDeptMapper extends BaseMapper<SDept> {

    @Select("<script>" +
            "SELECT * " +
            "FROM s_dept where del_flag = '0' and flag = '1' order by sort asc</script> ")
    List<ResultSDeptDTO> getDeptList(QuerySDeptDTO dictionary);



    @Select("<script>SELECT * FROM s_dept WHERE 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \"> and DEL_FLAG = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \"> and FLAG = #{flag} </if>"
            + "<if test=\"name !=null and name != '' \"> and NAME like concat('%',#{name},'%') </if> "
            + " order by sort asc</script>")

    List<SDept> findAll(SDept sysDept);
    @Select("<script>" +
            " select s.BUSINESS_ID FROM " +
            " s_dept s " +
            "where s.PARENT_ID=#{parentId} and s.`NAME` like concat('%',#{type},'%')" +
            "</script>")
    String selectByParentId (@Param("parentId") String parentId,@Param("type")String type);
}
