package com.isoft91.gonn.gps.business.mapper;


import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import com.isoft91.gonn.gps.business.dto.*;
import com.isoft91.gonn.gps.business.entity.SDictionary;
import org.apache.ibatis.annotations.*;

import java.util.List;

/**
 * <p>
 * 数据字典 Mapper 接口
 * </p>
 *
 * @author 91isoft
 * @since 2019-12-25
 */
@Mapper
public interface SDictionaryMapper extends BaseMapper<SDictionary> {

    @Select("<script>" +
            "SELECT * " +
            "FROM s_dictionary where del_flag = '0' and flag = '1' </script> ")
    List<ResultSDictionaryDTO> getDictionaryList(QuerySDictionaryDTO dictionary);


    @Select("<script>" +
            "  SELECT value,#{mapper} as name FROM `s_dictionary` where type = #{serviceType} " +
            " </script> ")
    @Results({
            @Result(property = "child", javaType = List.class, column = "{value=value,name=name}",
                    many = @Many(select = "com.isoft91.gonn.pms.business.sdictionary.mapper.SDictionaryMapper.selectChild"))
    })
    List<ResultSearchDTO> selectGradeList(String serviceType, String mapper);

    @Select("<script>" +
            " select s1.business_id,s1.type,s1.name,s1.value, s2.name as serviceName from s_dictionary s1 " +
            "left join s_dictionary s2 on s1.value = s2.value " +
            "where s1.value LIKE concat('%',#{value},'%') and s1.Type = #{name} and s2.type = #{value} " +
            " </script> ")
    List<ResultSDictionaryDTO> selectChild(String value, String name);

    @Select("<script>SELECT " +
            "sd.`NAME` AS NAME, " +
            "sd.`VALUE` AS " +
            "VALUE " +
            " " +
            "FROM " +
            "s_dictionary sd " +
            "WHERE " +
            "sd.FLAG = #{flag} " +
            "AND sd.DEL_FLAG = #{delFlag} " +
            "AND sd.TYPE = #{type}</script>")
    List<SdProjectStageDTO> getProjecetStage(SDictionary sDictionary);

    @Select("<script>SELECT " +
            "sd.`NAME` AS NAME, " +
            "sd.`VALUE` AS " +
            "VALUE " +
            " " +
            "FROM " +
            "s_dictionary sd " +
            "WHERE " +
            "sd.FLAG = #{flag} " +
            "AND sd.DEL_FLAG = #{delFlag} " +
            "AND sd.TYPE = #{type}</script>")
    List<SdServiceStageDTO> getServiceStage(SDictionary sDictionary);


    @Select("<script>" +
            "SELECT " +
            "sd.`NAME` " +
            "FROM " +
            "s_dictionary sd " +
            "WHERE " +
            "sd.`VALUE` = #{value} " +
            "AND sd.TYPE = #{type} " +
            "and sd.FLAG='1' " +
            " and sd.DEL_FLAG='0' " +
            "</script>")
    List<String> NameByTypeValue(@Param("type") String type, @Param("value") String value);

    @Select("<script>" +
            "SELECT " +
            "sd.`VALUE` " +
            "FROM " +
            "s_dictionary sd " +
            "WHERE " +
            "sd.`NAME` = #{name} " +
            "AND sd.TYPE = #{type} " +
            "and sd.FLAG='1' " +
            " and sd.DEL_FLAG='0' " +
            "</script>")
    List<String> valueByTypeName(@Param("type") String type, @Param("name") String name);

    @Select("<script>" +
            "SELECT " +
            "sd.BUSINESS_ID, " +
            "sd.TYPE, " +
            "sd.NAME, " +
            "sd.VALUE, " +
            "sd.REMARKS, " +
            "su1.NAME as createName, " +
            "sd.CREATE_DATE, " +
            "su2.NAME as updateName, " +
            "sd.UPDATE_DATE " +
            "FROM " +
            "s_dictionary sd " +
            "LEFT JOIN s_user su1 ON sd.CREATE_BY = su1.BUSINESS_ID " +
            "LEFT JOIN s_user su2 ON sd.UPDATE_BY = su2.BUSINESS_ID " +
            "WHERE " +
            "<if test=\"querySDictionaryDTO.delFlag!=null\"> sd.DEL_FLAG=#{querySDictionaryDTO.delFlag}</if>\n" +
            "<if test=\"querySDictionaryDTO.flag!=null and querySDictionaryDTO.flag !=''\">AND sd.FLAG=#{querySDictionaryDTO.flag}</if>\n" +
            "<if test=\"querySDictionaryDTO.name!=null and querySDictionaryDTO.name !=''\"> AND sd.NAME like concat('%',#{querySDictionaryDTO.name},'%') </if>" +
            "<if test=\"querySDictionaryDTO.type!=null and querySDictionaryDTO.type !=''\"> AND sd.TYPE like concat('%',#{querySDictionaryDTO.type},'%') </if>" +
            "<if test=\"querySDictionaryDTO.value!=null and querySDictionaryDTO.value !='' \"> AND sd.VALUE like concat('%',#{querySDictionaryDTO.value},'%') </if>" +
            "order By sd.CREATE_DATE DESC" +
            "</script>")
    IPage<ResultSDictionaryPageDTO> selSDictionaryPage(@Param("querySDictionaryDTO") QuerySDictionaryDTO querySDictionaryDTO, @Param("page") Page page);
}
