package com.isoft91.gonn.gps.business.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.isoft91.gonn.gps.business.entity.SUser;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;

/**
 * <p>
 * 用户表 Mapper 接口
 * </p>
 *
 * @author jiangpengpeng
 * @since 2020-01-09
 */
public interface SUserMapper extends BaseMapper<SUser> {


    /**
     * @param sUserList
     * @return
     */
    @Insert("<script>insert into s_user(business_id," +
            "name," +
            "login_name," +
            "password," +
            "sex," +
            "email, " +
            "remarks," +
            "dept_id," +
            "create_by," +
            "create_date," +
            "update_by," +
            "update_date," +
            "del_flag," +
            "flag) value" +
            "<foreach collection =\"sUserList\" item=\"item\"  separator=\",\" > " +
            "(" +
            "#{item.businessId}," +
            "#{item.name}," +
            "#{item.loginName}," +
            "#{item.password}," +
            "#{item.sex}," +
            "#{item.email}," +
            "#{item.remarks}," +
            "#{item.deptId}," +
            "#{item.createBy}," +
            "#{item.createDate}," +
            "#{item.updateBy}," +
            "#{item.updateDate}," +
            "#{item.delFlag}," +
            "#{item.flag}" +
            ")" +
            "</foreach></script>")
    int saveUserSYN(@Param("sUserList") List<SUser> sUserList);


    /**
     * 删除
     */
    @Update("delete from s_user where 1=1")
    void removeAll();

    @Select("<script> " +
            "select su.`NAME`  from s_user_role sur,  s_user su where " +
            "sur.ROLE_ID=#{roleId}  and sur.USER_ID=su.BUSINESS_ID  " +
            "<if test=\"userId!='' and userId != null\"> AND su.BUSINESS_ID = #{userId} </if> " +
            "<if test=\"deptId!='' and deptId != null\"> and su.DEPT_ID=#{deptId}</if> " +
            "</script>")
    String selectName(@Param("userId") String userId, @Param("deptId") String deptId, @Param("roleId") String roleId);

    @Select("<script> " +
            "select su.BUSINESS_ID  from s_user_role sur,  s_user su where " +
            "sur.ROLE_ID=#{roleId}  and sur.USER_ID=su.BUSINESS_ID  " +
            "<if test=\"userId!='' and userId != null\"> AND su.BUSINESS_ID = #{userId} </if> " +
            "<if test=\"deptId!='' and deptId != null\"> and su.DEPT_ID=#{deptId}</if> " +
            "</script>")
    List<Integer> selectId(@Param("userId") String userId, @Param("deptId") String deptId, @Param("roleId") String roleId);

}
