package com.isoft91.gonn.gps.business.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.isoft91.gonn.gps.business.dto.QuerySDictionaryDTO;
import com.isoft91.gonn.gps.business.dto.ResultSearchDTO;
import com.isoft91.gonn.gps.business.dto.SdProjectStageDTO;
import com.isoft91.gonn.gps.business.dto.SdServiceStageDTO;
import com.isoft91.gonn.gps.business.entity.SDictionary;
import com.isoft91.gonn.gps.utils.Result.Ret;


import java.util.List;
import java.util.Map;

/**
 * <p>
 * 数据字典 服务类
 * </p>
 *
 * @author 91isoft
 * @since 2019-12-25
 */
public interface ISDictionaryService extends IService<SDictionary> {

    int logicalDelete(String id);

    int delete(String id);

    List getDictionaryList(QuerySDictionaryDTO sDictionary);
    SDictionary getDictionaryByID(String sDictionaryId);
    IPage getDictionaryListPage(Page page, QuerySDictionaryDTO sDictionary);


    /**
     * 条件分页查询数据字典
     */
    IPage getDictionaryListPageBy(Page page,QuerySDictionaryDTO querySDictionaryDTO);

    List getDictionaryListByType(String type);


    Map getGradeDic();

    /**
     * 查询所有模板类型数据
     */
    List<ResultSearchDTO> getTemplateTypeList();
    /**
     * 查询所有模板级别数据
     */
    List<ResultSearchDTO> getTemplateGradeList();

    Ret<List<SdProjectStageDTO>> getProjecetStage();

    Ret<List<SdServiceStageDTO>> getServiceStage();
}
