package com.isoft91.gonn.gps.business.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.isoft91.gonn.gps.business.dto.QuerySDeptDTO;
import com.isoft91.gonn.gps.business.dto.ResultSDeptDTO;
import com.isoft91.gonn.gps.business.entity.SDept;
import com.isoft91.gonn.gps.business.mapper.SDeptMapper;
import com.isoft91.gonn.gps.business.service.ISDeptService;
import com.isoft91.gonn.gps.utils.DozerUtils;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 部门表 服务实现类
 * </p>
 *
 * @author 91isoft
 * @since 2019-12-30
 */
@Service
public class SDeptServiceImpl extends ServiceImpl<SDeptMapper, SDept> implements ISDeptService {

    @Override
    public int logicalDelete(String id) {
        SDept sDept = new SDept();
        sDept.setDeleted();
        sDept.setStop();
        sDept.setBusinessId(id);
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("business_id", id);
        int line = this.baseMapper.updateById(sDept);
        return line;
    }

    @Override
    public int delete(String id) {
        return this.baseMapper.deleteById(id);
    }

    @Override
    public List getDeptList(QuerySDeptDTO sDeptDTO) {
        QueryWrapper queryWrapper = getQueryWrapper(sDeptDTO);
        queryWrapper.select().orderByDesc("SORT");
        List<SDept> sDepts = this.baseMapper.selectList(queryWrapper);
        List<ResultSDeptDTO> resultSDeptDTOSDtos = DozerUtils.mapList(sDepts, ResultSDeptDTO.class);
        return resultSDeptDTOSDtos;
    }

    @Override
    public IPage getDeptListPage(Page page, QuerySDeptDTO sDeptDTO) {
        QueryWrapper queryWrapper = getQueryWrapper(sDeptDTO);
        return this.baseMapper.selectPage(page, queryWrapper);
    }

    private QueryWrapper getQueryWrapper(QuerySDeptDTO sDeptDTO) {
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.ne("del_flag", "1");
        queryWrapper.ne("flag", "0");
        if (StrUtil.isNotBlank(sDeptDTO.getBusinessId())){
            queryWrapper.eq("busienss_id", sDeptDTO.getBusinessId());
        }
        return queryWrapper;
    }
}
