package com.isoft91.gonn.gps.business.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.isoft91.gonn.gps.business.dto.QuerySRoleDTO;
import com.isoft91.gonn.gps.business.dto.ResultSRoleDTO;
import com.isoft91.gonn.gps.business.entity.SRole;
import com.isoft91.gonn.gps.business.mapper.SRoleMapper;
import com.isoft91.gonn.gps.business.service.ISRoleService;
import com.isoft91.gonn.gps.utils.DozerUtils;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 角色表 服务实现类
 * </p>
 *
 * @author 91isoft
 * @since 2019-12-30
 */
@Service
public class SRoleServiceImpl extends ServiceImpl<SRoleMapper, SRole> implements ISRoleService {

    
    @Override
    public int logicalDelete(String id) {
        SRole sRole = new SRole();
        sRole.setDeleted();
        sRole.setStop();
        sRole.setBusinessId(id);
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("business_id", id);
        int line = this.baseMapper.updateById(sRole);
        return line;
    }

    @Override
    public int delete(String id) {
        return this.baseMapper.deleteById(id);
    }

    @Override
    public List getRoleList(QuerySRoleDTO sRole) {
        QueryWrapper queryWrapper = getQueryWrapper(sRole);
        List<SRole> sRoles = this.baseMapper.selectList(queryWrapper);
        List<ResultSRoleDTO> resultSRoleDTOS = DozerUtils.mapList(sRoles, ResultSRoleDTO.class);
        return resultSRoleDTOS;
    }

    @Override
    public IPage getRoleListPage(Page page, QuerySRoleDTO sRole) {
        QueryWrapper queryWrapper = getQueryWrapper(sRole);
        return this.baseMapper.selectPage(page, queryWrapper);
    }

    @Override
    public List getRoleListById(String id) {
        return null;
    }

    private QueryWrapper getQueryWrapper(QuerySRoleDTO sRole) {
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.ne("del_flag", "1");
        queryWrapper.ne("flag", "0");
        if (StrUtil.isNotBlank(sRole.getBusinessId())) {
            queryWrapper.eq("busienss_id", sRole.getBusinessId());
        }
        return queryWrapper;
    }
}
