package com.isoft91.gonn.gps.common.entity;


import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import java.io.Serializable;
import java.util.UUID;

/**
 * Created with family.
 * author: cy
 * Date: 16/6/2
 * Time: 上午9:15
 * description: id entity
 */
@Data
public abstract class IdEntity<T> extends DataEntity<T>  implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    @TableId("BUSINESS_ID")
    @TableField(fill = FieldFill.INSERT)
    private String businessId;

    @TableField(exist = false)
    protected String token;


    public void setBusinessId(String businessId) {
        this.businessId = businessId;
    }



    /**
     * 通用设置ID
     */
    public void setCommonBusinessId(){
        this.setBusinessId(UUID.randomUUID().toString().replaceAll("-", ""));
    }
}