package com.isoft91.gonn.gps.config.exception;

import com.isoft91.gonn.gps.utils.Result.*;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestControllerAdvice;
import org.springframework.web.multipart.MaxUploadSizeExceededException;

import javax.servlet.http.HttpServletRequest;

@RestControllerAdvice
public class MyExceptionHandler {
    @Value("${spring.servlet.multipart.max-file-size}")
    private String maxFileSize;

    @ExceptionHandler(MaxUploadSizeExceededException.class)
    @ResponseBody
    public Ret uploadException(MaxUploadSizeExceededException e)  {
        return Ret.error().setMsg("超出支持的最大上传文件大小(" + maxFileSize +")！");
    }

    @ExceptionHandler(Exception.class)
    @ResponseBody
    public Ret<?> handleException(HttpServletRequest request, Exception ex) {
        String msg = null;
        if (ex instanceof ExceptionCommon) {
            ExceptionCommon bizException = (ExceptionCommon) ex;
            msg = bizException.getMessage();
        }
        if (msg == null) {
            msg = ex.getMessage();
        }
        return  Ret.error().setData(msg);
    }
}
