package com.isoft91.gonn.gps.config.mybatisPlus;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.isoft91.gonn.gps.common.entity.DelStatus;
import com.isoft91.gonn.gps.common.entity.FlagStatus;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.util.UUID;

/**
 * @description: This is a handler class for meta object.
 * @author: Breaker93
 * @createTime: 2019/9/21 11:08
 */
@Component
public class MyMetaObjectHandler implements MetaObjectHandler {
    @Override
    public void insertFill(MetaObject metaObject) {
        //String user = (String) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
        System.out.println(UUID.randomUUID().toString().replaceAll("-", ""));
        this.setFieldValByName("businessId",  UUID.randomUUID().toString().replaceAll("-", ""), metaObject);
        //this.setFieldValByName("createBy", user, metaObject);
        this.setFieldValByName("createDate", LocalDateTime.now(), metaObject);
        //this.setFieldValByName("updateBy", user, metaObject);
        this.setFieldValByName("updateDate", LocalDateTime.now(), metaObject);
        this.setFieldValByName("delFlag", DelStatus.NORMAL.getStatus(), metaObject);
        if (metaObject.getValue("flag") == null){
            this.setFieldValByName("flag", FlagStatus.NORMAL.getStatus(), metaObject);
        }

    }

    @Override
    public void updateFill(MetaObject metaObject) {
        String user = (String) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
//        User user = (User) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
        this.setFieldValByName("updateBy", user, metaObject);
        this.setFieldValByName("updateDate", LocalDateTime.now(), metaObject);
    }
}
