package com.isoft91.gonn.gps.config.swagger;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

/**
 * Swagger2配置类
 *
 * @author David
 */
@Configuration
@EnableSwagger2
public class SwaggerConfig {
    //@Value("${swagger.swagger}")
    //private boolean enableSwagger;
    @Bean
    public Docket createRestApi() {
        return new Docket(DocumentationType.SWAGGER_2)
                .apiInfo(apiInfo())
                //.enable(enableSwagger)
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.isoft91.gonn.pms.business"))
                .paths(PathSelectors.any())
                .build();
    }


    private ApiInfo apiInfo() {
        return new ApiInfoBuilder()
                .title("主要业务服务")
                .description("业务模块接口API")
                .termsOfServiceUrl("http://127.0.0.1:8089/")
                .version("1.0")
                .build();
    }
}
