package com.isoft91.gonn.gps.sys.controller;

import com.isoft91.gonn.gps.sys.service.CommonMesServiceImpl;
import com.isoft91.gonn.gps.utils.Result.Ret;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.security.NoSuchAlgorithmException;

/**
 * TODO
 *
 * @author :jiangpengpeng
 * @date:2020/3/25 13:38
 */
@RequestMapping("/commonMes")
@RestController
public class CommonMesController {

    @Autowired
    CommonMesServiceImpl commonMesService;

    @GetMapping("/getPermission")
    @ApiOperation(value = "权限", notes = "查询区域")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "timestamp" ,value="sha1加密" ,required = true ),
            @ApiImplicitParam(name = "sign", value = "md5加密timestamp", required = true),
            @ApiImplicitParam(name = "userId", value = "用户id", required = true)
    })
    public Ret getPermission(String timestamp ,String sign,String userId,String flag) throws NoSuchAlgorithmException {
        return commonMesService.getPermission(timestamp,sign,userId,flag);
    }


    @GetMapping("/getArea")
    @ApiOperation(value = "查询区域", notes = "查询区域")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "timestamp" ,value="sha1加密" ,required = true ),
            @ApiImplicitParam(name = "sign", value = "md5加密timestamp", required = true)
    })
    public Ret getArea(String timestamp ,String sign){
        return commonMesService.getArea(timestamp,sign);
    }


    @GetMapping("/getServiceLine")
    @ApiOperation(value = "查询业务线", notes = "查询业务线")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "timestamp" ,value="sha1加密" ,required = true ),
            @ApiImplicitParam(name = "sign", value = "md5加密timestamp", required = true)
    })
    public Ret getServiceLine(String timestamp ,String sign){
        return commonMesService.getServiceLine(timestamp,sign);
    }

    @GetMapping("/getOperator")
    @ApiOperation(value = "查询运营商", notes = "查询运营商")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "timestamp" ,value="sha1加密" ,required = true ),
            @ApiImplicitParam(name = "sign", value = "md5加密timestamp", required = true)
    })
    public Ret getOperator(String timestamp ,String sign){
        return commonMesService.getOperator(timestamp,sign);
    }



    @GetMapping("/getNeedSouce")
    @ApiOperation(value = "查询需求来源", notes = "查询需求来源")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "timestamp" ,value="sha1加密" ,required = true ),
            @ApiImplicitParam(name = "sign", value = "md5加密timestamp", required = true)
    })
    public Ret getNeedSouce(String timestamp ,String sign){
        return  commonMesService.getNeedSouce(timestamp,sign);
    }


    @GetMapping("/getUpper")
    @ApiOperation(value = "查询上游客户", notes = "查询上游客户")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "timestamp" ,value="sha1加密" ,required = true ),
            @ApiImplicitParam(name = "sign", value = "md5加密timestamp", required = true)
    })
    public Ret getUpper(String timestamp ,String sign){
        return commonMesService.getUpper(timestamp,sign);
    }

    @GetMapping("/getJzState")
    @ApiOperation(value = "查询基站状态", notes = "查询基站状态")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "timestamp" ,value="sha1加密" ,required = true ),
            @ApiImplicitParam(name = "sign", value = "md5加密timestamp", required = true)
    })
    public Ret getJzState(String timestamp ,String sign){
        return commonMesService.getJzState(timestamp,sign);
    }

}
