package com.isoft91.gonn.gps.sys.controller;

import com.isoft91.gonn.gps.utils.Result.Ret;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/file")
public class FileController {
    @Value("${file.upload}")
    private String uploadPath;

    @PostMapping("/uploadList")
    public Ret upload(@RequestParam("files") MultipartFile[] files){
        List fileList = new ArrayList();
        // 多文件上传
        for (MultipartFile file : files){
            // 带后缀名的文件名
            String originalFilename = file.getOriginalFilename();
            int index = originalFilename.lastIndexOf(".");
            //获取文件的后缀名
            String suffix = "";
            String noSuffixFilename = originalFilename;
            if(index != -1){
                suffix = originalFilename.substring(originalFilename.lastIndexOf("."));
                noSuffixFilename = originalFilename.substring(0, index);
            }

            // DONE: 获取文件file除去后缀名后的文件名
            String newFilename = new StringBuilder(noSuffixFilename).append(".").append(System.currentTimeMillis()).append(suffix).toString();
            // 存储路径
            String filePath = new StringBuilder(uploadPath)
                    .append(File.separator)
                    .append(newFilename)
                    .toString();
            File targetFile = new File(filePath);
            File parentFile = new File(uploadPath);
            try {
                if(!parentFile.exists()){
                    parentFile.mkdirs();

                }
                if(!targetFile.exists()){
                    targetFile.createNewFile();
                }
                // 保存文件
                file.transferTo(targetFile);
                Map fileInfo = new HashMap();
                fileInfo.put("name", originalFilename);
                fileInfo.put("url", newFilename);
                fileList.add(fileInfo);
            } catch (IOException e) {
                e.printStackTrace();
                return Ret.error().setMsg(e.getMessage());
            }
        }
        return Ret.ok().setData(fileList);
    }

    @PostMapping("/upload")
    public Ret upload(MultipartFile file){
        // 带后缀名的文件名
        String originalFilename = file.getOriginalFilename();
        int index = originalFilename.lastIndexOf(".");
        //获取文件的后缀名
        String suffix = "";
        String noSuffixFilename = originalFilename;
        if(index != -1){
            suffix = originalFilename.substring(originalFilename.lastIndexOf("."));
            noSuffixFilename = originalFilename.substring(0, index);
        }

        // DONE: 获取文件file除去后缀名后的文件名
        String newFilename = new StringBuilder(noSuffixFilename).append(".").append(System.currentTimeMillis()).append(suffix).toString();
        // 存储路径
        String filePath = new StringBuilder(uploadPath)
                .append(File.separator)
                .append(newFilename)
                .toString();
        File targetFile = new File(filePath);
        File parentFile = new File(uploadPath);
        try {
            if(!parentFile.exists()){
                parentFile.mkdirs();

            }
            if(!targetFile.exists()){
                targetFile.createNewFile();
            }
            // 保存文件
            file.transferTo(targetFile);
            Map fileInfo = new HashMap();
            fileInfo.put("name", originalFilename);
            fileInfo.put("url", newFilename);
            return Ret.ok().setData(fileInfo);
        } catch (IOException e) {
            e.printStackTrace();
            return Ret.error().setMsg(e.getMessage());
        }

    }

    @PostMapping("/remove")
    public Ret remove(String url){
        String path = new StringBuilder(uploadPath).append(File.separator).append(url).toString();
        File file = new File(path);
        if(file.delete()){
            return Ret.ok();
        }else {
           return Ret.error().setMsg("文件删除失败");
        }
    }

    @PostMapping("/download")
    public void download(HttpServletResponse response, String url) throws FileNotFoundException {
        // 下载本地文件
        String filePath = new StringBuilder(uploadPath).append(File.separator).append(url).toString();
        // 读到流中
        InputStream inStream = new FileInputStream(filePath);// 文件的存放路径
        // 设置输出的格式
//        response.reset();
        response.setContentType("bin");
        response.addHeader("Content-Disposition", "attachment; filename=\"" + url + "\"");
        // 循环取出流中的数据
        byte[] b = new byte[100];
        int len;
        try {
            while ((len = inStream.read(b)) > 0)
                response.getOutputStream().write(b, 0, len);
            inStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
