package com.isoft91.gonn.gps.sys.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import com.isoft91.gonn.gps.sys.entity.User;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface UserMapper extends BaseMapper<User> {


    /**根据角色id查询用户*/
    @Select("select * from `user` where `user`.BUSINESS_ID in(SELECT s_user_role.USER_ID from s_user_role where s_user_role.ROLE_ID=#{roleId})")
    List<User> selectUserByRoleId(@Param("roleId")String roleId);
    /**查询所有用户*/
    @Select("select * from user")
    List<User> selectAllUser();
    /**根据部门id查询用户*/
    @Select("SELECT `user`.* FROM `user` JOIN s_dept ON `user`.DEPT_ID = s_dept.BUSINESS_ID WHERE s_dept.BUSINESS_ID = #{deptId}")
    List<User> selectUserByDeptId(String deptId);
}
