package com.isoft91.gonn.gps.sys.service;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 11:19  2019/9/11
 * @Modified By:
 */

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.isoft91.gonn.gps.utils.Result.Ret;
import com.isoft91.gonn.gps.utils.http.HttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @Description: 金蝶物料接口实现类
 * @date 2019/1/4 14:24
 */
@Transactional
@Service
@Slf4j
public class KingdeeServiceImpl {







    public Ret login(String url, String content) {
        ResponseEntity<String> responseEntity = HttpUtil.httpPost(url, content);
        //获取登录cookie
        if (responseEntity.getStatusCode() == HttpStatus.OK) {
            String login_cookie = "";
            Set<String> keys = responseEntity.getHeaders().keySet();
            for (String key : keys) {
                if (key.equalsIgnoreCase("Set-Cookie")) {
                    List<String> cookies = responseEntity.getHeaders().get(key);
                    for (String cookie : cookies) {
                        if (cookie.startsWith("kdservice-sessionid")) {
                            login_cookie = cookie;
                            break;
                        }
                    }
                }
            }
            Map<String, Object> map = new HashMap<>();
            map.put("cookie", login_cookie);
            return Ret.ok().setData(map);
        }

        Map<String, Object> result = JSON.parseObject(responseEntity.getBody());
        return Ret.error().setMsg(result.get("Message").toString());
    }




    public Ret save(String url, String cookie, String content) {
        //保存
        Map<String, Object> header = new HashMap<>();
        header.put("Cookie", cookie);
        String result = HttpUtil.httpPost(url, header, content);
        JSONObject jsonObject = JSON.parseObject(result);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("Result");
        Map<String, Object> responseStatus = (Map<String, Object>) map.get("ResponseStatus");
        Boolean isSuccess = (Boolean) responseStatus.get("IsSuccess");
        if (isSuccess) {
            return Ret.ok().setData(JSON.toJSONString(map));
        } else {
            List<Map<String, Object>> errors = (List<Map<String, Object>>) responseStatus.get("Errors");
            return Ret.error().setData(JSON.toJSONString(errors));
        }
    }


}

