package com.isoft91.gonn.gps.utils;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 11:16  2019/9/11
 * @Modified By:
 */

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @date 2019/1/7 15:58
 */
@Slf4j
public class BaseUtil {


    private BaseUtil() {
    }

    ;

    /**
     * 构造登录参数
     *
     * @param dbid     账套id
     * @param userName 用户名
     * @param password 密码
     * @param lang     语言
     * @return
     */
    public static String buildLogin(String dbid, String userName, String password, int lang) {
        Map<String, Object> param = new HashMap<>(4);
        param.put("acctID", dbid);
        param.put("username", userName);
        param.put("password", password);
        param.put("lcid", lang);
        return JSON.toJSONString(param);

    }


    /**
     * 构造付款单参数
     *
     * @return {@link }
     * @throws
     * @author jiangpengpeng
     * @date 2020/2/7 14:36
     */
    public static String buildPay(String template, String payMes, String formid) {
        JSONObject basic = JSON.parseObject(template);
        Map<String, Object> model = (Map<String, Object>) basic.get("Model");
        /*=====================================================配置参数*/
        Map fbilltypeid = (Map) model.get("FBILLTYPEID");
        fbilltypeid.put("FNUMBER", "FKSQ001_SYS");

        model.put("FDATE", "2020-03-24 00:00:00");

        model.put("FCONTACTUNITTYPE", "BD_Supplier");

        Map fcontactunit = (Map) model.get("FCONTACTUNIT");
        fcontactunit.put("FNumber", "GSGYS-0001");

        model.put("FRECTUNITTYPE", "BD_Supplier");

        Map frectunit = (Map) model.get("FRECTUNIT");
        frectunit.put("FNumber", "GSGYS-0001");

        Map fcurrencyid = (Map) model.get("FCURRENCYID");
        fcurrencyid.put("FNumber", "PRE001");

        Map fpayorgid = (Map) model.get("FPAYORGID");
        fpayorgid.put("FNumber", "1000");

        Map fsettleorgid = (Map) model.get("FSETTLEORGID");
        fsettleorgid.put("FNumber", "1000");

        Map fpurchaseorgid = (Map) model.get("FPURCHASEORGID");
        fpurchaseorgid.put("FNumber", "1000");

        Map fpurchasedeptid = (Map) model.get("FPURCHASEDEPTID");
        fpurchasedeptid.put("FNumber", "01.00");

        model.put("FDOCUMENTSTATUS", "Z");

        model.put("FCANCELSTATUS", "A");

        Map fapplyorgid = (Map) model.get("FAPPLYORGID");
        fapplyorgid.put("FNumber", "1000");

        Map fsettlecur = (Map) model.get("FSETTLECUR");
        fsettlecur.put("FNUMBER", "PRE001");

        List<Map> fpayapplyentry = (List<Map>) model.get("FPAYAPPLYENTRY");
        Map fpaypurposeid = (Map) fpayapplyentry.get(0).get("FPAYPURPOSEID");
        fpaypurposeid.put("FNumber", "SFKYT08_SYS");

        fpayapplyentry.get(0).put("FENDDATE", "2020-03-24 00:00:00");

        fpayapplyentry.get(0).put("FEXPECTPAYDATE", "2020-03-24 00:00:00");

        fpayapplyentry.get(0).put("FAPPLYAMOUNTFOR", 1000.0);

        basic.put("Model", model);
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("formid", formid);
        jsonObject.put("data", basic);
        return jsonObject.toString();
    }

    /**
     * 构造提交、审核参数
     *
     * @param formid  表单id
     * @param numbers 编码 多个编码以,分隔
     * @param numbers 审核标示 多个以,分隔 和编码一一对应
     * @return
     */
    public static String buildParam(String formid, String numbers, String flags) {
        JSONObject jsonObject = new JSONObject();
        JSONObject param = new JSONObject();
        if (flags != null) {
            String[] arr_flag = flags.split(",");
            param.put("InterationFlags", arr_flag);
        }
        String[] arr_number = numbers.split(",");
        param.put("Numbers", arr_number);
        jsonObject.put("formid", formid);
        jsonObject.put("data", JSON.toJSONString(param));
        return JSON.toJSONString(jsonObject);
    }

    /**
     * 构造获取合同参数
     *
     * @param formid      表单id
     * @param projectCode 项目编号
     * @param
     * @return
     */
    public static Map buileContract(String projectCode, String formid) {
        Map<String, Object> param = new HashMap<>();
        param.put("formid", formid);
        param.put("number", projectCode);
        return param;
    }




}

