package com.isoft91.gonn.gps.utils;

import com.alibaba.fastjson.JSONObject;
import com.isoft91.gonn.gps.sys.service.KingdeeServiceImpl;
import com.isoft91.gonn.gps.utils.Result.Ret;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.HttpEntity;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.util.EntityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.IOException;
import java.util.Map;

/**
 * TODO
 *
 * @author :jiangpengpeng
 * @date:2020/2/7 13:47
 */

@Transactional
@Service
@Slf4j
public class KingdeeCommon {


    @Autowired
    KingDeeUrl kingDeeUrl;

    @Autowired
    KingdeeServiceImpl kingdeeService;

    /**
     * 金蝶登录方法
     *
     * @return {@link }
     * @throws
     * @author jiangpengpeng
     * @date 2020/2/7 13:49
     */
    public String KindeeLogin() {
        String loginParam = BaseUtil.buildLogin(kingDeeUrl.getDBid(), kingDeeUrl.getUsername(), kingDeeUrl.getPassword(), kingDeeUrl.getIcon());
        Ret login = kingdeeService.login(kingDeeUrl.getUrl() + kingDeeUrl.getLogin(), loginParam);
        if ("400".equals(login.getCode())) {
            // this.dbError("登录金蝶系统失败" +login.getMessage());
            log.info("【登录金蝶系统失败】：{}", login.getMsg());
            return null;
        } else {
            Map<String, Object> map = (Map<String, Object>) login.getData();
            return map.get("cookie").toString();
        }
    }

    public String getTask(String url, String date) {
        CloseableHttpResponse response = null;
        CloseableHttpClient httpClient = HttpClientBuilder.create().build();
        try {
            HttpPost httpPost = new HttpPost(url);
            httpPost.setHeader("Content-Type", "application/json;charset=utf-8");
            StringEntity postingString = new StringEntity(date, "utf-8");
            httpPost.setEntity(postingString);

            // 配置信息
            RequestConfig requestConfig = RequestConfig.custom()
                    // 设置连接超时时间(单位毫秒)
                    .setConnectTimeout(5000)
                    // 设置请求超时时间(单位毫秒)
                    .setConnectionRequestTimeout(5000)
                    // socket读写超时时间(单位毫秒)
                    .setSocketTimeout(5000)
                    // 设置是否允许重定向(默认为true)
                    .setRedirectsEnabled(true).build();

            // 将上面的配置信息 运用到这个post请求里
            httpPost.setConfig(requestConfig);

            // 由客户端执行(发送)post请求
            response = httpClient.execute(httpPost);

            // 从响应模型中获取响应实体
            HttpEntity responseEntity = response.getEntity();
            if (response.getStatusLine().getStatusCode() == 200 && responseEntity != null) {
                //取出实体中的数据
                String str = EntityUtils.toString(responseEntity);
                //将数据转换成json数据
                JSONObject jsonObject = JSONObject.parseObject(str);
                String code = jsonObject.get("code").toString();
                return jsonObject.toJSONString();

            }
        } catch (Exception e) {

        } finally {
            try {
                // 释放资源
                if (httpClient != null) {
                    httpClient.close();
                }
                if (response != null) {
                    response.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
            return "";
        }


    }
}
